﻿using EVCB_OCPP.WEBAPI.Handlers;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Http;
using System.Web.Http.ExceptionHandling;
using static EVCB_OCPP.WEBAPI.Handlers.APILogHandler;

namespace EVCB_OCPP.WEBAPI
{
    public static class WebApiConfig
    {
        public static void Register(HttpConfiguration config)
        {
            config.Formatters.JsonFormatter.SerializerSettings = new JsonSerializerSettings
            {
                NullValueHandling = NullValueHandling.Ignore,
                DateFormatString = EVCBConfiguration.UTC_DATETIMEFORMAT
            };

            config.MessageHandlers.Add(new ApiLogHandler());
            // Web API 設定和服務
            config.Services.Replace(typeof(IExceptionHandler), new GlobalExceptionHandler());
            // Web API 路由
            config.MapHttpAttributeRoutes();

            config.Routes.MapHttpRoute(
                name: "DefaultApi",
                routeTemplate: "api/v1/{controller}/{id}",
                defaults: new { id = RouteParameter.Optional }
            );
        }
    }
}
