﻿using EVCB_OCPP.WEBAPI.Models.WebAPI;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Threading;
using System.Threading.Tasks;
using System.Web;
using System.Web.Http;
using System.Web.Http.ExceptionHandling;

namespace EVCB_OCPP.WEBAPI.Handlers
{
    public class GlobalExceptionHandler: ExceptionHandler
    {
        

        public override void Handle(ExceptionHandlerContext context)
        {
           
            if (ShouldHandle(context))
            {
            
                context.Result = new TextPlainErrorResult() { Request = context.Request  };
            }
        }


        private class TextPlainErrorResult : IHttpActionResult
        {
            public HttpRequestMessage Request { get; set; }

      

            public Task<HttpResponseMessage> ExecuteAsync(CancellationToken cancellationToken)
            {
                var result = new CPOOuterResponse() {  StatusMessage = CPO_StatusMessage.ERROR_MSG_Global_UNEXPECTEDERROR, StatusCode = (int)CPO_StatusCode.UnexpectedError };

                var resultString = JsonConvert.SerializeObject(result,EVCBConfiguration.JSONSERIALIZER_FORMAT);
                HttpResponseMessage response = Request.CreateResponse(HttpStatusCode.InternalServerError, result);                                
                response.RequestMessage = Request;
                return Task.FromResult(response);
            }
        }


    }
}